javax.persistence.criteria

## Interface AbstractQuery<T>

Type Parameters:
  `T` - the type of the result

All Superinterfaces:
  CommonAbstractCriteria

All Known Subinterfaces:
  CriteriaQuery<T>, Subquery<T>

    public interface AbstractQuery<T>
    extends CommonAbstractCriteria

The `AbstractQuery` interface defines functionality that is common to both top-level queries and subqueries. It is not intended to be used directly in query construction.

All queries must have: a set of root entities (which may in turn own joins).

All queries may have: a conjunction of restrictions.

Since:
  Java Persistence 2.0

### Method Summary

All Methods Instance Methods Abstract Methods
`AbstractQuery<T>` `distinct(boolean distinct)` Specify whether duplicate query results will be eliminated.
`<X> Root<X>` `from(java.lang.Class<X> entityClass)` Create and add a query root corresponding to the given entity, forming a cartesian product with any existing roots.
`<X> Root<X>` `from(EntityType<X> entity)` Create and add a query root corresponding to the given entity, forming a cartesian product with any existing roots.
`java.util.List<Expression<?>>` `getGroupList()` Return a list of the grouping expressions.
`Predicate` `getGroupRestriction()` Return the predicate that corresponds to the restriction(s) over the grouping items, or null if no restrictions have been specified.
`java.lang.Class<T>` `getResultType()` Return the result type of the query or subquery.
`java.util.Set<Root<?>>` `getRoots()` Return the query roots.
`Selection<T>` `getSelection()` Return the selection of the query, or null if no selection has been set.
`AbstractQuery<T>` `groupBy(Expression<?>... grouping)` Specify the expressions that are used to form groups over the query results.
`AbstractQuery<T>` `groupBy(java.util.List<Expression<?>> grouping)` Specify the expressions that are used to form groups over the query results.
`AbstractQuery<T>` `having(Expression<java.lang.Boolean> restriction)` Specify a restriction over the groups of the query.
`AbstractQuery<T>` `having(Predicate... restrictions)` Specify restrictions over the groups of the query according the conjunction of the specified restriction predicates.
`boolean` `isDistinct()` Return whether duplicate query results must be eliminated or retained.
`AbstractQuery<T>` `where(Expression<java.lang.Boolean> restriction)` Modify the query to restrict the query results according to the specified boolean expression.
`AbstractQuery<T>` `where(Predicate... restrictions)` Modify the query to restrict the query results according to the conjunction of the specified restriction predicates.

### Methods inherited from interface javax.persistence.criteria.CommonAbstractCriteria

`getRestriction, subquery`

### Method Detail

#### from

    <X> Root<X> from(java.lang.Class<X> entityClass)

Create and add a query root corresponding to the given entity, forming a cartesian product with any existing roots.

Parameters:
  `entityClass` - the entity class
Returns:
  query root corresponding to the given entity

#### from

    <X> Root<X> from(EntityType<X> entity)

Create and add a query root corresponding to the given entity, forming a cartesian product with any existing roots.

Parameters:
  `entity` - metamodel entity representing the entity of type X
Returns:
  query root corresponding to the given entity

#### where

    AbstractQuery<T> where(Expression<java.lang.Boolean> restriction)

Modify the query to restrict the query results according to the specified boolean expression. Replaces the previously added restriction(s), if any.

Parameters:
  `restriction` - a simple or compound boolean expression
Returns:
  the modified query

#### where

    AbstractQuery<T> where(Predicate... restrictions)

Modify the query to restrict the query results according to the conjunction of the specified restriction predicates. Replaces the previously added restriction(s), if any. If no restrictions are specified, any previously added restrictions are simply removed.

Parameters:
  `restrictions` - zero or more restriction predicates
Returns:
  the modified query

#### groupBy

    AbstractQuery<T> groupBy(Expression<?>... grouping)

Specify the expressions that are used to form groups over the query results. Replaces the previous specified grouping expressions, if any. If no grouping expressions are specified, any previously added grouping expressions are simply removed.

Parameters:
  `grouping` - zero or more grouping expressions
Returns:
  the modified query

#### groupBy

    AbstractQuery<T> groupBy(java.util.List<Expression<?>> grouping)

Specify the expressions that are used to form groups over the query results. Replaces the previous specified grouping expressions, if any. If no grouping expressions are specified, any previously added grouping expressions are simply removed.

Parameters:
  `grouping` - list of zero or more grouping expressions
Returns:
  the modified query

#### having

    AbstractQuery<T> having(Expression<java.lang.Boolean> restriction)

Specify a restriction over the groups of the query. Replaces the previous having restriction(s), if any.

Parameters:
  `restriction` - a simple or compound boolean expression
Returns:
  the modified query

#### having

    AbstractQuery<T> having(Predicate... restrictions)

Specify restrictions over the groups of the query according the conjunction of the specified restriction predicates. Replaces the previously having added restriction(s), if any. If no restrictions are specified, any previously added restrictions are simply removed.

Parameters:
  `restrictions` - zero or more restriction predicates
Returns:
  the modified query

#### distinct

    AbstractQuery<T> distinct(boolean distinct)

Specify whether duplicate query results will be eliminated. A true value will cause duplicates to be eliminated. A false value will cause duplicates to be retained. If distinct has not been specified, duplicate results must be retained.

Parameters:
  `distinct` - boolean value specifying whether duplicate results must be eliminated from the query result or whether they must be retained
Returns:
  the modified query

#### getRoots

    java.util.Set<Root<?>> getRoots()

Return the query roots. These are the roots that have been defined for the `CriteriaQuery` or `Subquery` itself, including any subquery roots defined as a result of correlation. Returns empty set if no roots have been defined. Modifications to the set do not affect the query.

Returns:
  the set of query roots

#### getSelection

    Selection<T> getSelection()

Return the selection of the query, or null if no selection has been set.

Returns:
  selection item

#### getGroupList

    java.util.List<Expression<?>> getGroupList()

Return a list of the grouping expressions. Returns empty list if no grouping expressions have been specified. Modifications to the list do not affect the query.

Returns:
  the list of grouping expressions

#### getGroupRestriction

    Predicate getGroupRestriction()

Return the predicate that corresponds to the restriction(s) over the grouping items, or null if no restrictions have been specified.

Returns:
  having clause predicate

#### isDistinct

    boolean isDistinct()

Return whether duplicate query results must be eliminated or retained.

Returns:
  boolean indicating whether duplicate query results must be eliminated

#### getResultType

    java.lang.Class<T> getResultType()

Return the result type of the query or subquery. If a result type was specified as an argument to the `createQuery` or `subquery` method, that type will be returned. If the query was created using the `createTupleQuery` method, the result type is `Tuple`. Otherwise, the result type is `Object`.

Returns:
  result type